commit a2baadd1378c84df8e1f9eabc172ef8bd0ef5da1
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Wed Apr 2 22:39:01 2014 +0200

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/cas/cas.admin.inc b/drupal7/sites/all/modules/cas/cas.admin.inc
index 4c209a22..08967fd3 100644
--- a/drupal7/sites/all/modules/cas/cas.admin.inc
+++ b/drupal7/sites/all/modules/cas/cas.admin.inc
@@ -310,11 +310,13 @@ function cas_admin_settings() {
       ),
     ),
   );
+
   $form['advanced']['cas_proxy_settings']['cas_pgtformat'] = array(
     '#type' => 'radios',
     '#title' => t('CAS PGT storage file format'),
     '#default_value' => variable_get('cas_pgtformat', 'plain'),
     '#options' => array('plain' => t('Plain Text'), 'xml' => t('XML')),
+    '#after_build' => array('cas_pgtformat_version_check'),
   );
 
   $form['advanced']['cas_proxy_settings']['cas_pgtpath'] = array(
@@ -325,6 +327,14 @@ function cas_admin_settings() {
     '#description' => t("Only needed if 'Use CAS proxy initializer' is configured. Leave empty for default."),
   );
 
+  $form['advanced']['cas_proxy_list'] = array(
+    '#type' => 'textarea',
+    '#title' => t('CAS proxy list'),
+    '#description' => t("If CAS client could be proxied, indicate each proxy server absolute url per line. If not provided, phpCAS will exclude by default all tickets provided by proxy. Each proxy server url could be a plain url or a regular expression. IMPORTANT : regular expression delimiter must be a slash. For example : https://proxy.example.com/ AND/OR regular expression : /^https:\/\/app[0-9]\.example\.com\/rest\//."),
+    '#default_value' => variable_get('cas_proxy_list', ''),
+    '#after_build' => array('cas_proxy_list_version_check'),
+  );
+
   $form['advanced']['cas_debugfile'] = array(
     '#type' => 'textfield',
     '#title' => t('CAS debugging output filename'),
@@ -359,3 +369,24 @@ function cas_library_version_check($element, &$form_state) {
   }
   return $element;
 }
+
+/**
+ * Proxy chain object only exists with phpCAS version >= 1.3. As phpCAS CAS.php
+ * is include only after building element 'cas_library_dir', we must check it after it.
+ */
+function cas_proxy_list_version_check($element, &$form_state) {
+  if (!defined('PHPCAS_VERSION') || version_compare(PHPCAS_VERSION, '1.3', '<')) {
+    $element['#access'] = FALSE;
+  }
+  return $element;
+}
+
+/**
+ * Since 1.3, pgt format isn't supported and default to plain.
+ */
+function cas_pgtformat_version_check($element, &$form_state) {
+  if (!defined('PHPCAS_VERSION') || version_compare(PHPCAS_VERSION, '1.3', '>')) {
+    $element['#access'] = FALSE;
+  }
+  return $element;
+}
diff --git a/drupal7/sites/all/modules/cas/cas.drush.inc b/drupal7/sites/all/modules/cas/cas.drush.inc
index 6ad97d37..a975a09f 100644
--- a/drupal7/sites/all/modules/cas/cas.drush.inc
+++ b/drupal7/sites/all/modules/cas/cas.drush.inc
@@ -10,6 +10,19 @@
  */
 function cas_drush_command() {
   $items = array();
+  $items['cas-user-add-role'] = array(
+    'callback' => 'cas_drush_user_add_role',
+    'description' => 'Add a role to the specified CAS usernames.',
+    'arguments' => array(
+      'role' => 'The name of the role to add',
+      'users' => '(optional) A comma delimited list of CAS user names.',
+    ),
+    'required-arguments' => 1,
+    'examples' => array(
+      'drush cas-user-add-role "power user" casuser1,casuser2' =>
+        'Add the "power user" role to the accounts with CAS user names casuser1 and casuser2.',
+    ),
+  );
   $items['cas-user-create'] = array(
     'callback' => 'cas_drush_user_create',
     'description' => dt('Create a CAS user account with the specified CAS username.'),
@@ -25,12 +38,14 @@ function cas_drush_command() {
 }
 
 /**
- * Implementats hook_drush_help().
+ * Implements hook_drush_help().
  */
 function cas_drush_help($section) {
   switch ($section) {
     case 'drush:cas-user-create':
       return dt('Create a CAS user account with the specified CAS username.');
+    case 'drush:cas-user-add-role':
+      return dt('Add a role to the specified CAS usernames.');
   }
 }
 
@@ -57,3 +72,54 @@ function cas_drush_user_create($cas_name) {
     drush_set_error(dt('There is already a user account with CAS username @cas_name.', array('@cas_name' => $cas_name)));
   }
 }
+
+/**
+ * Add a role to the specified CAS user accounts.
+ */
+function cas_drush_user_add_role($role, $users = '') {
+  $uids = cas_drush_user_get_users_from_arguments($users);
+  if (drush_drupal_major_version() >= 7) {
+    $rid_query = db_query("SELECT rid FROM {role} WHERE name = :role", array(':role' => $role));
+  }
+  else {
+    $rid_query = db_query("SELECT rid FROM {role} WHERE name = '%s'", $role);
+  }
+  if (!empty($uids)) {
+    if ($rid = drush_db_result($rid_query)) {
+      drush_op('user_multiple_role_edit', $uids, 'add_role', $rid);
+      foreach ($uids as $uid) {
+        drush_log(dt("Added the !role role to uid !uid", array('!role' => $role, '!uid' => $uid)), 'success');
+      }
+    }
+    else {
+      return drush_set_error(dt("There is no role named: !role", array('!role' => $role)));
+    }
+  }
+  else {
+    return drush_set_error("Could not find any valid uids!");
+  }
+}
+
+/**
+ * Look up user ids from a comma-separated list of CAS usernames.
+ *
+ * @param $users string
+ *   Comma separated list of CAS usernames.
+ *
+ * @return array
+ *   An array of user ids corresponding to the given CAS usernames. Unknown
+ *   CAS usernames are ignored.
+ */
+function cas_drush_user_get_users_from_arguments($users) {
+  $uids = array();
+  if ($users !== '') {
+    $users = explode(',', $users);
+    foreach ($users as $user) {
+      $account = cas_user_load_by_name($user);
+      if ($account) {
+        $uids[] = $account->uid;
+      }
+    }
+  }
+  return $uids;
+}
diff --git a/drupal7/sites/all/modules/cas/cas.info b/drupal7/sites/all/modules/cas/cas.info
index 384e9909..a600e3bd 100644
--- a/drupal7/sites/all/modules/cas/cas.info
+++ b/drupal7/sites/all/modules/cas/cas.info
@@ -7,9 +7,9 @@ configure = admin/config/people/cas
 files[] = cas.test
 files[] = includes/views/handlers/cas_handler_field_cas_name.inc
 
-; Information added by drupal.org packaging script on 2012-05-09
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "cas"
-datestamp = "1336595150"
+datestamp = "1396458247"
 
diff --git a/drupal7/sites/all/modules/cas/cas.install b/drupal7/sites/all/modules/cas/cas.install
index 8c481bee..d9d11986 100644
--- a/drupal7/sites/all/modules/cas/cas.install
+++ b/drupal7/sites/all/modules/cas/cas.install
@@ -99,6 +99,7 @@ function cas_uninstall() {
   variable_del('cas_pgtpath');
   variable_del('cas_port');
   variable_del('cas_proxy');
+  variable_del('cas_proxy_list');
   variable_del('cas_registerURL');
   variable_del('cas_server');
   variable_del('cas_uri');
diff --git a/drupal7/sites/all/modules/cas/cas.module b/drupal7/sites/all/modules/cas/cas.module
index 7b8c247b..75ff6fb6 100644
--- a/drupal7/sites/all/modules/cas/cas.module
+++ b/drupal7/sites/all/modules/cas/cas.module
@@ -99,7 +99,7 @@ function cas_login_check($force_authentication = TRUE) {
   if (empty($cas_user['login']) || empty($cas_user['name'])) {
     // Only set a warning if we forced login.
     if ($force_authentication) {
-      drupal_set_message(t('The user account %name is not available on this site.', array('%name' => $cas_name)), 'error');
+      drupal_set_message(t('The user account %name is not available on this site.', array('%name' => $cas_user['name'])), 'error');
     }
     return;
   }
@@ -159,7 +159,7 @@ function cas_login_check($force_authentication = TRUE) {
     $edit['cas_user'] = $cas_user;
     $edit['roles'] = $account->roles + cas_roles();
     if (module_exists('persistent_login') && !empty($_SESSION['cas_remember'])) {
-      $edit['persistent_login'] = 1;
+      $edit['values']['persistent_login'] = 1;
     }
     // Allow other modules to make their own custom changes.
     cas_user_module_invoke('presave', $edit, $account);
@@ -179,7 +179,7 @@ function cas_login_check($force_authentication = TRUE) {
     $user = drupal_anonymous_user();
     // Only display error messages only if the user intended to log in.
     if ($force_authentication) {
-      drupal_set_message(t('No account found for %cas_name.', array('%cas_name' => $cas_name)));
+      drupal_set_message(t('No account found for %cas_name.', array('%cas_name' => $cas_name)), 'error');
     }
   }
 }
@@ -243,21 +243,35 @@ function cas_phpcas_init() {
   $server_port       = (int)variable_get('cas_port', '443');
   $server_uri        = (string)variable_get('cas_uri', '');
   $cas_cert          = (string)variable_get('cas_cert', '');
-  if ( ($debugFile = variable_get("cas_debugfile", "")) != "" ) {
-    phpCAS::setDebug($debugFile);
+  $debug_file        = (string)variable_get('cas_debugfile', '');
+  if ($debug_file != '') {
+    phpCAS::setDebug($debug_file);
   }
   $start_session = (boolean)FALSE;
-  if ( variable_get("cas_proxy", 0) ) {
+  if (variable_get('cas_proxy', 0)) {
     phpCAS::proxy($server_version, $server_cas_server, $server_port, $server_uri, $start_session);
-    $casPGTStoragePath = variable_get("cas_pgtpath", "");
-    if ( $casPGTStoragePath != "" ) {
-      $casPGTFormat = variable_get("cas_pgtformat", "plain");
-      phpCAS::setPGTStorageFile($casPGTFormat, $casPGTStoragePath);
+    $cas_pgt_storage_path = variable_get('cas_pgtpath', '');
+    if ($cas_pgt_storage_path != '') {
+      if (version_compare(PHPCAS_VERSION, '1.3', '>=')) {
+        phpCAS::setPGTStorageFile($cas_pgt_storage_path);
+      }
+      else {
+        $cas_pgt_format = variable_get('cas_pgtformat', 'plain');
+        phpCAS::setPGTStorageFile($cas_pgt_format, $cas_pgt_storage_path);
+      }
     }
   }
   else {
     phpCAS::client($server_version, $server_cas_server, $server_port, $server_uri, $start_session);
   }
+
+  //Add CAS proxy lists allowed
+  $proxy_list = variable_get('cas_proxy_list', '');
+  if ($proxy_list) {
+    $proxy_list = explode("\n", $proxy_list);
+    phpCAS::allowProxyChain(new CAS_ProxyChain($proxy_list));
+  }
+
   // force CAS authentication
   if ($cas_cert = variable_get('cas_cert', '')) {
     phpCAS::setCasServerCACert($cas_cert);
@@ -380,8 +394,8 @@ function cas_menu_site_status_alter(&$menu_site_status, $path) {
  * Implements hook_menu_link_alter().
  *
  * Flag this link as needing alter at display time.
- * @see cas_translated_menu_link_alter().
- **/
+ * @see cas_translated_menu_link_alter()
+ */
 function cas_menu_link_alter(&$item) {
   if ($item['link_path'] == 'cas' || $item['link_path'] == 'caslogout') {
     $item['options']['alter'] = TRUE;
@@ -392,7 +406,7 @@ function cas_menu_link_alter(&$item) {
  * Implements hook_translated_menu_item_alter().
  *
  * Append dynamic query 'destination' to several menu items.
- **/
+ */
 function cas_translated_menu_link_alter(&$item) {
   if ($item['href'] == 'cas') {
     $item['localized_options']['query'] = drupal_get_destination();
@@ -437,7 +451,7 @@ function cas_user_operations($form = array(), $form_state = array()) {
  *   An array of user ids. For each account, a CAS username is created with
  *   the same name as the Drupal username.
  *
- * @see cas_user_operations().
+ * @see cas_user_operations()
  */
 function cas_user_operations_create_username($uids) {
   $accounts = user_load_multiple($uids);
@@ -463,7 +477,7 @@ function cas_user_operations_create_username($uids) {
  * @param $uids
  *   An array of user ids. For each account, all CAS usernames are removed.
  *
- * @see cas_user_operations().
+ * @see cas_user_operations()
  */
 function cas_user_operations_remove_usernames($uids) {
   db_delete('cas_user')
@@ -590,12 +604,15 @@ function cas_user_delete($account) {
  * @param $alter
  *   If TRUE, run the CAS username through hook_cas_user_alter() before
  *   loading the account.
+ * @param $reset
+ *   TRUE to reset the internal cache and load from the database; FALSE
+ *   (default) to load from the internal cache, if set.
  *
  * @return
  *   A fully-loaded $user object upon successful user load or FALSE if user
  *   cannot be loaded.
  */
-function cas_user_load_by_name($cas_name, $alter = FALSE) {
+function cas_user_load_by_name($cas_name, $alter = FALSE, $reset = FALSE) {
   if ($alter) {
     $cas_user = array(
       'name' => $cas_name,
@@ -606,9 +623,9 @@ function cas_user_load_by_name($cas_name, $alter = FALSE) {
     $cas_name = $cas_user['name'];
   }
 
-  $uid = db_query("SELECT uid FROM {cas_user} WHERE cas_name = :cas_name", array(':cas_name' => $cas_name))->fetchField();
+  $uid = db_select('cas_user')->fields('cas_user', array('uid'))->condition('cas_name', db_like($cas_name), 'LIKE')->range(0, 1)->execute()->fetchField();
   if ($uid) {
-    return user_load($uid);
+    return user_load($uid, $reset);
   }
   return FALSE;
 }
@@ -623,14 +640,17 @@ function cas_user_load_by_name($cas_name, $alter = FALSE) {
 function cas_login_page($cas_first_login = FALSE) {
   global $user;
   $destination = '';
+  $query = array();
   // If it is the user's first CAS login and initial login redirection is enabled, go to the set page
   if ($cas_first_login && variable_get('cas_first_login_destination', '')) {
     $destination = variable_get('cas_first_login_destination', '');
+    if (isset($_GET['destination']))
+      $query['destination'] = $_GET['destination'];
     unset($_GET['destination']);
   }
 
   // Respect the query string, if transmitted.
-  drupal_goto($destination);
+  drupal_goto($destination, array('query' => $query));
 }
 
 /**
@@ -654,8 +674,6 @@ function cas_logout($invoke_hook = TRUE) {
 
   // Build the logout URL.
   cas_phpcas_init();
-  $logout_url = phpCAS::getServerLogoutURL();
-  $options = array();
 
   if (isset($_GET['destination']) && !url_is_external($_GET['destination'])) {
     // Add destination override so that a destination can be specified on the
@@ -671,23 +689,23 @@ function cas_logout($invoke_hook = TRUE) {
   //Make it an absolute url.  This will also convert <front> to the front page.
   if ($destination) {
     $destination_url = url($destination, array('absolute' => TRUE));
-    $options['query'] = array(
-      'destination' => $destination_url,
+    $options = array(
       'service' => $destination_url,
       'url' => $destination_url,
     );
   }
+  else {
+    $options = array();
+  }
 
   // Mimic user_logout().
   if ($invoke_hook) {
     watchdog('user', 'Session closed for %name.', array('%name' => $user->name));
     module_invoke_all('user_logout', $user);
   }
-  session_destroy();
 
-  // Force redirection in drupal_goto().
-  unset($_GET['destination']);
-  drupal_goto($logout_url, $options);
+  // phpCAS automatically calls session_destroy().
+  phpCAS::logout($options);
 }
 
 /**
@@ -745,7 +763,7 @@ function cas_login_block($form) {
  * Determine if we should automatically check if the user is authenticated.
  *
  * This implements part of the CAS gateway feature.
- * @see phpCAS::checkAuthentication().
+ * @see phpCAS::checkAuthentication()
  *
  * @return
  *   TRUE if we should query the CAS server to see if the user is already
@@ -763,33 +781,35 @@ function _cas_allow_check_for_login() {
   }
 
   // Check to see if we've got a search bot.
-  $crawlers = array(
-    'Google',
-    'msnbot',
-    'Rambler',
-    'Yahoo',
-    'AbachoBOT',
-    'accoona',
-    'AcoiRobot',
-    'ASPSeek',
-    'CrocCrawler',
-    'Dumbot',
-    'FAST-WebCrawler',
-    'GeonaBot',
-    'Gigabot',
-    'Lycos',
-    'MSRBOT',
-    'Scooter',
-    'AltaVista',
-    'IDBot',
-    'eStyle',
-    'Scrubby',
-    'gsa-crawler',
-    );
-  // Return on the first find.
-  foreach ($crawlers as $c) {
-    if (stripos($_SERVER['HTTP_USER_AGENT'], $c) !== FALSE) {
-      return FALSE;
+  if (isset($_SERVER['HTTP_USER_AGENT'])) {
+    $crawlers = array(
+      'Google',
+      'msnbot',
+      'Rambler',
+      'Yahoo',
+      'AbachoBOT',
+      'accoona',
+      'AcoiRobot',
+      'ASPSeek',
+      'CrocCrawler',
+      'Dumbot',
+      'FAST-WebCrawler',
+      'GeonaBot',
+      'Gigabot',
+      'Lycos',
+      'MSRBOT',
+      'Scooter',
+      'AltaVista',
+      'IDBot',
+      'eStyle',
+      'Scrubby',
+      'gsa-crawler',
+      );
+    // Return on the first find.
+    foreach ($crawlers as $c) {
+      if (stripos($_SERVER['HTTP_USER_AGENT'], $c) !== FALSE) {
+        return FALSE;
+      }
     }
   }
 
@@ -869,7 +889,6 @@ function _cas_force_login() {
  */
 function cas_form_alter(&$form, &$form_state, $form_id) {
 
-  //drupal_set_message($form_id.'<pre>'.print_r($form,1).'</pre>');
   switch ($form_id) {
     case 'user_login':
     case 'user_login_block':
@@ -953,14 +972,16 @@ function cas_form_alter(&$form, &$form_state, $form_id) {
         }
         if (variable_get('cas_hide_password', 0)) {
           $form['account']['pass']['#access'] = FALSE;
-
-          // Also remove requirement to validate your current password before
-          // changing your e-mail address.
-          $form['account']['current_pass']['#access'] = FALSE;
-          $form['account']['current_pass_required_values']['#access'] = FALSE;
-          $form['#validate'] = array_diff($form['#validate'], array('user_validate_current_pass'));
         }
       }
+      if (cas_is_external_user($account) && variable_get('cas_hide_password', 0)) {
+        // Also remove requirement to validate your current password before
+        // changing your e-mail address.
+        $form['account']['current_pass']['#access'] = FALSE;
+        $form['account']['current_pass_required_values']['#access'] = FALSE;
+        $form['account']['current_pass_required_values']['#value'] = array();
+        $form['#validate'] = array_diff($form['#validate'], array('user_validate_current_pass'));
+      }
       break;
 
     case 'user_pass':
@@ -1046,7 +1067,7 @@ function cas_login_submit(&$form, &$form_state) {
 
 function _cas_single_sign_out_check() {
   if (isset($_POST["logoutRequest"])) {
-    $cas_logout_request_xml_string = utf8_encode($_POST["logoutRequest"]);     // it's important!
+    $cas_logout_request_xml_string = utf8_encode(urldecode($_POST["logoutRequest"]));
     $cas_logout_request_xml = new SimpleXMLElement($cas_logout_request_xml_string);
     if (is_object($cas_logout_request_xml)) {
       $namespaces = $cas_logout_request_xml->getNameSpaces();
@@ -1061,20 +1082,19 @@ function _cas_single_sign_out_check() {
         // Log them out now.
         // first lets find out who we want to log off
 
-        $result = db_query_range("SELECT cld.uid FROM {cas_login_data} cld WHERE cld.cas_session_id = :ticket", 0 , 1, array(':ticket' => $cas_session_index));
-        foreach ($result as $record) {
-            $uid = $record->uid;
-            $acct = user_load($uid);
-            watchdog('user', 'Session closed for %name.', array('%name' => $acct->name));
-            // remove all entry for user id in cas_login_data
-            db_delete('cas_login_data')
-              ->condition('uid', $uid)
-              ->execute();
-
-            // remove their session
-            db_delete('sessions')
-              ->condition('uid', $uid)
-              ->execute();
+
+        $record = db_query_range("SELECT cld.uid, u.name FROM {users} u JOIN {cas_login_data} cld ON u.uid = cld.uid WHERE cld.cas_session_id = :ticket", 0, 1, array(':ticket' => $cas_session_index))->fetchObject();
+        if ($record) {
+          watchdog('user', 'Session closed for %name by CAS logout request.', array('%name' => $record->name));
+          //remove all entry for user id in cas_login_data
+          db_delete('cas_login_data')
+            ->condition('uid', $record->uid)
+            ->execute();
+
+          // remove their session
+          db_delete('sessions')
+            ->condition('uid', $record->uid)
+            ->execute();
         }
       }
     }
@@ -1238,7 +1258,7 @@ function cas_user_register($cas_name, $options = array()) {
  * Get the CAS attributes of the current CAS user.
  *
  * Ensures that phpCAS is properly initialized before getting the attributes.
- * @see phpCAS::getAttributes().
+ * @see phpCAS::getAttributes()
  *
  * @param $cas_name
  *   If provided, ensure that the currently logged in CAS user matches this
diff --git a/drupal7/sites/all/modules/cas/cas.pages.inc b/drupal7/sites/all/modules/cas/cas.pages.inc
index 8e8f25f4..5105ea53 100644
--- a/drupal7/sites/all/modules/cas/cas.pages.inc
+++ b/drupal7/sites/all/modules/cas/cas.pages.inc
@@ -9,7 +9,7 @@
  * Menu callback; Manage CAS identities for the specified user.
  */
 function cas_user_identities($account) {
-  drupal_set_title(format_username($account));
+  drupal_set_title(check_plain(format_username($account)));
 
   $header = array(t('CAS username'), t('Operations'));
   $rows = array();
diff --git a/drupal7/sites/all/modules/cas/cas.test b/drupal7/sites/all/modules/cas/cas.test
index a0970fd9..154efa47 100644
--- a/drupal7/sites/all/modules/cas/cas.test
+++ b/drupal7/sites/all/modules/cas/cas.test
@@ -35,7 +35,7 @@ class CasTestHelper extends DrupalWebTestCase {
     $this->admin_user = $this->drupalCreateUser(array('administer users', 'administer cas'));
 
     // Download and extract in PHPCAS.
-    $this->downloadExtractPhpCas('1.2.2');
+    $this->downloadExtractPhpCas('1.3.1');
   }
 
   /**
@@ -77,16 +77,6 @@ class CasTestHelper extends DrupalWebTestCase {
       // Extract the files.
       $archiver = archiver_get_archiver($local_archive);
       $archiver->extract($simpletest_cache);
-      // Work around issue https://issues.jasig.org/browse/PHPCAS-105.
-      // @see http://drupal.org/node/1120034
-      switch ($version) {
-        case '1.1.3':
-          system_retrieve_file('http://drupal.org/files/issues/CAS-1.1.3-CAS-client.txt', $cas_library_dir . '/CAS/client.php', FALSE, FILE_EXISTS_REPLACE);
-          break;
-        case '1.2.1':
-          system_retrieve_file('http://drupal.org/files/issues/CAS-1.2.1-CAS-client_0.txt', $cas_library_dir . '/CAS/client.php', FALSE, FILE_EXISTS_REPLACE);
-          break;
-      }
     }
     if (function_exists('sem_get')) {
       sem_release($semaphore);
@@ -145,17 +135,41 @@ class CasTestHelper extends DrupalWebTestCase {
     }
 
     // Log in the user.
-    $cas_name = is_object($account) ? $account->cas_name : $account;
-    $cas_user = array('name' => $cas_name, 'attributes' => $attributes);
-    variable_set('cas_test_cas_user', $cas_user);
+    $cas_name = $this->setCasUser($account, $attributes);
     $this->drupalGet('cas');
 
     $pass = $this->assertLink(t('Log out'), 0, t('CAS user %cas_name successfully logged in.', array('%cas_name' => $cas_name)), t('User login'));
     if ($pass) {
-      $this->loggedInUser = cas_user_load_by_name($cas_name, TRUE);
+      $this->loggedInUser = cas_user_load_by_name($cas_name, TRUE, TRUE);
     }
   }
 
+  /**
+   * Set the CAS username and attributes for the next CAS login request.
+   *
+   * @param $account
+   *   A user object with a valid CAS username field, or the CAS username as a
+   *   string.
+   * @param $attributes
+   *   Additional attributes for the CAS user.
+   *
+   * @return
+   *   The CAS username.
+   */
+  function setCasUser($account, $attributes = array()) {
+    $cas_name = is_object($account) ? $account->cas_name : $account;
+    $cas_user = array('name' => $cas_name, 'attributes' => $attributes);
+    variable_set('cas_test_cas_user', $cas_user);
+    return $cas_name;
+  }
+
+  /**
+   * Clear the CAS username and attributes for the next CAS login request.
+   */
+  function clearCasUser() {
+    variable_del('cas_test_cas_user');
+  }
+
   /**
    * Assert that the user has logged in.
    *
@@ -353,7 +367,7 @@ class CasUserTestCase extends CasTestHelper {
    */
   function testCasAutoRegister() {
     $cas_name = $this->randomName();
-    variable_set('cas_test_cas_user', array('name' => $cas_name));
+    $this->setCasUser($cas_name);
 
     // Test that the user is not automatically registered.
     variable_set('cas_user_register', FALSE);
@@ -370,7 +384,7 @@ class CasUserTestCase extends CasTestHelper {
     // Create a new user.
     $user2 = $this->drupalCreateUser();
     $cas_name = $user2->name;
-    variable_set('cas_test_cas_user', array('name' => $cas_name));
+    $this->setCasUser($cas_name);
 
     // Test that CAS does not hijack an existing username.
     $this->drupalGet('cas');
@@ -423,6 +437,13 @@ class CasUserTestCase extends CasTestHelper {
 
     $this->assertToken('[cas:name]', $account->cas_name);
   }
+
+  function testCaseInsensitiveLogin() {
+    $account = $this->casCreateUser();
+    $this->casLogin(strtoupper($account->cas_name));
+    $this->assertLoggedIn($account);
+  }
+
 }
 
 /**
@@ -510,7 +531,7 @@ class CasLoginRedirectionTestCase extends CasTestHelper {
     // Create a CAS user.
     $account = $this->casCreateUser();
     $cas_name = $account->cas_name;
-    variable_set('cas_test_cas_user', array('name' => $cas_name));
+    $this->setCasUser($cas_name);
 
     // Test going to 'cas'
     $this->drupalGet('cas');
@@ -572,7 +593,7 @@ class CasLoginRedirectionTestCase extends CasTestHelper {
     variable_set('cas_first_login_destination', "node/$node->nid");
     $cas_name = $this->randomName();
     $account = $this->casLogin($cas_name);
-    $this->assertUrl("node/$node->nid");
+    $this->assertUrl("node/$node->nid", array('query' => array('destination' => '')));
     $this->drupalLogout();
 
     // The second login should not be redirected.
@@ -584,7 +605,7 @@ class CasLoginRedirectionTestCase extends CasTestHelper {
     // destination.
     $account = $this->casCreateUser();
     $this->casLogin($account);
-    $this->assertUrl("node/$node->nid");
+    $this->assertUrl("node/$node->nid", array('query' => array('destination' => '')));
     $this->drupalLogout();
 
     // The second login should not be redirected.
@@ -619,6 +640,19 @@ class CasSingleSignOutTestCase extends CasTestHelper {
     // @todo: Add additional tests for other methods of logging in (especially
     //   methods coming from cas_pages).
   }
+
+  function testSingleSignOutDoubleEncode() {
+    // Create a user, and log in.
+    $cas_name = $this->randomName();
+    $account = $this->casCreateUser($cas_name);
+    $this->casLogin($account);
+
+    cas_test_single_sign_out($cas_name, TRUE);
+    $this->assertLoggedOut();
+
+    // @todo: Add additional tests for other methods of logging in (especially
+    //   methods coming from cas_pages).
+  }
 }
 
 /**
@@ -658,7 +692,7 @@ class CasGatewayTestCase extends CasTestHelper {
     // Create a user.
     $cas_name = $this->randomName();
     $account = $this->casCreateUser($cas_name);
-    variable_set('cas_test_cas_user', array('name' => $cas_name));
+    $this->setCasUser($cas_name);
 
     $this->drupalGet('node');
     $this->assertLoggedIn($account);
@@ -685,7 +719,7 @@ class CasRequiredLoginTestCase extends CasTestHelper {
     $node1 = $this->drupalCreateNode();
     $node2 = $this->drupalCreateNode();
     $account = $this->casCreateUser();
-    variable_set('cas_test_cas_user', array('name' => $account->cas_name));
+    $this->setCasUser($account);
 
     $this->drupalGet("node/$node2->nid");
 
@@ -707,7 +741,7 @@ class CasRequiredLoginTestCase extends CasTestHelper {
     $this->assertField('pass', t('Password field found.'), t('Logout'));
 
     // Verify that accessing any other page redirects to the login page.
-    variable_del('cas_test_cas_user');
+    $this->clearCasUser();
     $this->drupalGet('node');
     $this->assertText('No CAS name provided.');
   }
@@ -718,7 +752,7 @@ class CasRequiredLoginTestCase extends CasTestHelper {
   function testCasExclude() {
     $node = $this->drupalCreateNode();
     $account = $this->casCreateUser();
-    variable_set('cas_test_cas_user', array('name' => $account->cas_name));
+    $this->setCasUser($account);
 
     variable_set('cas_check_first', TRUE);
     variable_set('cas_exclude', "node/$node->nid");
@@ -786,7 +820,7 @@ class CasLoginBlockTestCase extends CasTestHelper {
    */
   function testCasLoginBlock() {
     $account = $this->casCreateUser();
-    variable_set('cas_test_cas_user', array('name' => $account->cas_name));
+    $this->setCasUser($account);
 
     // Verify that the block is shown on some pages, but not on others.
     $this->drupalGet('');
diff --git a/drupal7/sites/all/modules/cas/cas.user.inc b/drupal7/sites/all/modules/cas/cas.user.inc
index 628c657c..ed998543 100644
--- a/drupal7/sites/all/modules/cas/cas.user.inc
+++ b/drupal7/sites/all/modules/cas/cas.user.inc
@@ -16,7 +16,7 @@ function cas_add_user_form() {
     '#title' => t('CAS username'),
     '#required' => TRUE,
     '#default_value' => '',
-    '#description' => t('Registration will proceded as if the user with the specified CAS username just logged in.'),
+    '#description' => t('Registration will proceed as if the user with the specified CAS username just logged in.'),
     '#element_validate' => array('_cas_name_element_validate'),
     '#weight' => -10,
   );
diff --git a/drupal7/sites/all/modules/cas/cas_server.api.php b/drupal7/sites/all/modules/cas/cas_server.api.php
index 168247e2..ce6ec17c 100644
--- a/drupal7/sites/all/modules/cas/cas_server.api.php
+++ b/drupal7/sites/all/modules/cas/cas_server.api.php
@@ -33,7 +33,7 @@ function hook_cas_server_user_attributes($account, $service, $ticket) {
   $attributes['friends'] = array('dries', 'webchick');
 
   // Or change the response based upon the server.
-  if (preg_match($service, "@^http://apple.com/@")) {
+  if (preg_match("@^http://apple.com/@", $service)) {
     // This data should not be confidential as the service URL is directly
     // supplied by the user and is in no way validated.
     $attributes['friends'] += 'sjobs';
diff --git a/drupal7/sites/all/modules/cas/cas_server.info b/drupal7/sites/all/modules/cas/cas_server.info
index 5ca10914..1dc495b5 100644
--- a/drupal7/sites/all/modules/cas/cas_server.info
+++ b/drupal7/sites/all/modules/cas/cas_server.info
@@ -3,9 +3,9 @@ package = Central Authentication Service
 core = 7.x
 description = "Provides protocol compliant CAS Server"
 
-; Information added by drupal.org packaging script on 2012-05-09
-version = "7.x-1.2"
+; Information added by Drupal.org packaging script on 2014-04-02
+version = "7.x-1.3"
 core = "7.x"
 project = "cas"
-datestamp = "1336595150"
+datestamp = "1396458247"
 
diff --git a/drupal7/sites/all/modules/cas/cas_server.install b/drupal7/sites/all/modules/cas/cas_server.install
index 4e882a33..1e10b842 100644
--- a/drupal7/sites/all/modules/cas/cas_server.install
+++ b/drupal7/sites/all/modules/cas/cas_server.install
@@ -35,6 +35,11 @@ function cas_server_schema() {
         'type' => 'int',
         'not null' => TRUE,
       ),
+      'valid' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 1,
+      ),
     ),
     'primary key' => array('ticket'),
   );
@@ -46,7 +51,7 @@ function cas_server_schema() {
 /**
  * Creates CAS server tickets table.
  */
-function cas_server_update_1() {
+function cas_server_update_7000() {
   $schema = array();
 
   $schema['cas_server_tickets'] = array(
@@ -78,6 +83,13 @@ function cas_server_update_1() {
   );
 
   $ret = array();
-  db_create_table($ret, 'cas_server_tickets', $schema['cas_server_tickets']);
+  db_create_table('cas_server_tickets', $schema['cas_server_tickets']);
   return $ret;
 }
+
+/**
+ * Adds valid field to indicate when ticket is valid for reuse.
+ */
+function cas_server_update_7101() {
+  db_add_field('cas_server_tickets', 'valid', array('type' => 'int', 'not null' => TRUE, 'default' => 1, ));
+}
